package com.zhongshu.reward.client.model;

import com.zhongshu.reward.client.type.TimeUnitType;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @author wjf
 * @date 2024/8/12
 */
@Data
public class TransferRulerModel {

    private String id;

    private Long updateTime;

    private Long createTime;

    /**
     * 单笔最小提现金额
     */
    private BigDecimal minTotal = BigDecimal.ZERO;

    /**
     * 单笔最大提现金额
     */
    private BigDecimal maxTotal = BigDecimal.ZERO;

    /**
     * 单日最大转账金额
     */
    private BigDecimal dayMaxTotal = BigDecimal.ZERO;

    /**
     * 提现手续费
     */
    private BigDecimal commission = BigDecimal.ZERO;

    /**
     * 提现次数
     */
    private Integer size;

    /**
     * 时间单位
     */
    private TimeUnitType timeUnit;

    /**
     * 每月开始号数
     */
    private Integer startDay;

    /**
     * 每月结束号数
     */
    private Integer endDay;

    /**
     * 每日开始时
     */
    private Integer startHour;

    /**
     * 每日开始分
     */
    private Integer startMinute;

    /**
     * 每日结束时
     */
    private Integer endHour;

    /**
     * 每日结束分
     */
    private Integer endMinute;

}
