package com.zhongshu.reward.server.core.controller.wallet;

import com.github.microservice.auth.security.annotations.ResourceAuth;
import com.github.microservice.auth.security.type.AuthType;
import com.zhongshu.reward.server.core.domain.WalletReceipts;
import com.zhongshu.reward.server.core.service.StatisticsService;
import com.zhongshu.reward.server.core.service.WalletReceiptsService;
import io.swagger.annotations.Api;
import io.swagger.v3.oas.annotations.Operation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author wjf
 * @date 2024/8/12
 */

@Slf4j
@RestController
@RequestMapping("/invite")
@Api(tags = "推广邀请")
public class InviteController {

    @Autowired
    WalletReceiptsService walletReceiptsService;

    @Autowired
    StatisticsService statisticsService;

    @Operation(summary = "邀请奖励明细", description = "邀请奖励明细")
    @ResourceAuth(value = "user", type = AuthType.User)
    @GetMapping(value = "rewardDetailList")
    public Object rewardDetailList(@RequestParam("year") Integer year, @RequestParam("month") Integer month){
        return walletReceiptsService.rewardDetail(year, month);
    }

    @Operation(summary = "我的邀请", description = "我的邀请")
    @ResourceAuth(value = "user", type = AuthType.User)
    @GetMapping(value = "myInvite")
    public Object myInvite(){
        return statisticsService.myInvite();
    }
}
