package com.zhongshu.reward.server.core.dao.Impl;

import com.zhongshu.reward.server.core.dao.extend.VipUserRecordDaoExtend;
import com.zhongshu.reward.server.core.domain.VipUserRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;

import java.util.List;

/**
 * @author wjf
 * @date 2024/8/13
 */
public class VipUserRecordDaoImpl implements VipUserRecordDaoExtend {

    @Autowired
    MongoTemplate mongoTemplate;

    @Override
    public VipUserRecord findTopOneByOperateTime(String userId, Long startTime, Long endTime) {

        Criteria criteria = new Criteria();

        criteria.andOperator(Criteria.where("operateTime").gte(startTime),Criteria.where("operateTime").lte(endTime));

//        criteria.and("operateTime").gte(startTime);
//
//        criteria.and("operateTime").lte(endTime);


        criteria.and("cpId").is(userId);

        Query query = Query.query(criteria);
        query.with(Sort.by(Sort.Order.desc("operateTime")));
        List<VipUserRecord> vipUserRecords = mongoTemplate.find(query, VipUserRecord.class);
        if (vipUserRecords.isEmpty()){
            return null;
        }
        return vipUserRecords.get(0);
    }
}
