package com.zhongshu.reward.server.core.service;

import com.zhongshu.reward.client.model.InviteReceiptsRoleModel;
import com.zhongshu.reward.client.ret.ResultContent;
import com.zhongshu.reward.server.core.dao.InviteReceiptsRoleDao;
import com.zhongshu.reward.server.core.dao.VipUserRecordDao;
import com.zhongshu.reward.server.core.domain.InviteReceiptsRuler;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 邀请返利
 * @author wjf
 * @date 2024/8/7
 */
@Service
public class InviteReceiptsRulerService {

    @Autowired
    InviteReceiptsRoleDao inviteReceiptsRoleDao;

    @Autowired
    VipUserRecordDao vipUserRecordDao;

    @Autowired
    WalletReceiptsService walletReceiptsService;



    /**
     * 添加推广规则
     * @param inviteReceiptsRoleModel
     * @return
     */
//    public Object add(InviteReceiptsRoleModel inviteReceiptsRoleModel){
//        boolean existsBySetMeal= inviteReceiptsRoleDao.existsBySetMealIdAndDisable(inviteReceiptsRoleModel.getSetMealId(), false);
//        if (existsBySetMeal){
//            return ResultContent.buildFail("该套餐存在推广规则");
//        }
//        InviteReceiptsRuler inviteReceiptsRole = new InviteReceiptsRuler();
//        BeanUtils.copyProperties(inviteReceiptsRoleModel, inviteReceiptsRole);
//        return ResultContent.buildContent(toModel(inviteReceiptsRoleDao.save(inviteReceiptsRole)));
//    }

    public Object update(InviteReceiptsRoleModel inviteReceiptsRoleModel){
        if (StringUtils.isEmpty(inviteReceiptsRoleModel.getId())) {//添加
            boolean existsBySetMeal= inviteReceiptsRoleDao.existsBySetMealIdAndDisable(inviteReceiptsRoleModel.getSetMealId(), false);
            if (existsBySetMeal){
                return ResultContent.buildFail("该套餐存在推广规则");
            }
        }else if (!inviteReceiptsRoleDao.existsById(inviteReceiptsRoleModel.getId())){
            return ResultContent.buildContent("找不到要修改的推广规则");
        }

        InviteReceiptsRuler inviteReceiptsRuler = new InviteReceiptsRuler();
        BeanUtils.copyProperties(inviteReceiptsRoleModel, inviteReceiptsRuler);
        return ResultContent.buildContent(toModel(inviteReceiptsRoleDao.save(inviteReceiptsRuler)));
    }




    InviteReceiptsRoleModel toModel(InviteReceiptsRuler inviteReceiptsRuler){
        InviteReceiptsRoleModel model = new InviteReceiptsRoleModel();
        if (ObjectUtils.isNotEmpty(inviteReceiptsRuler)){
            BeanUtils.copyProperties(inviteReceiptsRuler, model);
        }
        return model;
    }
}
