package com.zhongshu.reward.server.core.stream;

import com.github.microservice.app.stream.StreamConsumer;
import com.zhongshu.reward.server.core.dao.VipUserRecordDao;
import com.zhongshu.reward.server.core.domain.VipUserRecord;
import com.zhongshu.reward.server.core.service.InviteReceiptsRulerService;
import com.zhongshu.reward.server.core.service.WalletReceiptsService;
import com.zhongshu.reward.server.core.util.DateUtils;
import com.zhongshu.vip.client.model.param.VipUserParam;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Log4j2
@Component("vipUserStreamConsumer")
public class VipUserStream extends StreamConsumer<VipUserParam> {

    @Autowired
    WalletReceiptsService walletReceiptsService;

    @Autowired
    VipUserRecordDao vipUserRecordDao;

    @Override
    public void accept(VipUserParam vipUserParam) {
        log.info("收到会员套餐消息：{}",vipUserParam);
        VipUserRecord vipUserRecord = new VipUserRecord();
        BeanUtils.copyProperties(vipUserParam, vipUserRecord, "createTime");
        vipUserRecord.setOperateTime(DateUtils.timeToLong(vipUserParam.getCreateTime(), DateUtils.FORMAT_LONG));
        walletReceiptsService.receipts(vipUserRecord);
    }
}
