package com.zhongshu.reward.server.core.timer;


import com.zhongshu.reward.client.type.TransferStatus;
import com.zhongshu.reward.server.core.dao.WalletDao;
import com.zhongshu.reward.server.core.dao.WxTransferBatchDao;
import com.zhongshu.reward.server.core.domain.WxTransferBatch;
import com.zhongshu.reward.server.core.service.WalletReceiptsService;
import com.zhongshu.reward.server.core.service.WxTransferService;
import com.zhongshu.reward.server.core.util.DateUtils;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.util.List;

/**
 * @author wjf
 * @date 2024/8/5
 */
@Component
@Log4j2
public class WalletTimer {

    @Autowired
    WalletDao walletDao;

    @Autowired
    WxTransferBatchDao wxTransferBatchDao;

    @Autowired
    WxTransferService wxTransferService;

    @Autowired
    WalletReceiptsService walletReceiptsService;

//    /**
//     * 重置每日提现额度
//     */
//    @Scheduled(cron = "0 0 0 * * ?")
//    public void resetTodayAmount(){
//        try {
//            walletDao.resetTodayAmount();
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//    }

    @Scheduled(fixedRate = 5000)
    public void updateTransferStatus(){
        try {
            List<WxTransferBatch> byTransferStatus = wxTransferBatchDao.findByTransferStatus(TransferStatus.PROCESSING);
            for (WxTransferBatch wxTransferBatch : byTransferStatus){
                wxTransferService.updateTransferStatus(wxTransferBatch.getId());
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @Scheduled(cron = "0 0 1 * * ?")
    public void settle(){
        try {
            LocalDate now = LocalDate.now();

            if (DateUtils.checkLastDayOfMonth() &&  now.getMonthValue() == 2){
                for (int i = now.getDayOfMonth(); i <= 31; i++) {
                    walletReceiptsService.settle(i);
                }
            }
            walletReceiptsService.settle(now.getDayOfMonth());
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @Scheduled(cron = "0 0 0 1 * ?")
    public void autoReceipts(){
        try {
            walletReceiptsService.autoReceipts();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
